class TTSSystem(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  symbol_to_id : Dict[str, int]
  sos_token : str
  eos_token : str
  set_accent : bool
  tts_model : __torch__.silero_vocoder.jit_model.MultiTTSModel
  def forward(self: __torch__.silero_vocoder.jit_model.TTSSystem,
    sentences: List[str],
    clean_sentences: List[str],
    break_lens: List[Optional[int]],
    prosody_rates: List[float],
    prosody_pitches: List[float],
    speaker_ids: Tensor,
    sr: int=48000,
    device: str="cpu",
    gt_durs: Optional[Tensor]=None,
    gt_pitch: Optional[Tensor]=None) -> Tuple[Tensor, Tensor]:
    _0 = (self).merge_batch_model(sentences, break_lens, prosody_rates, prosody_pitches, )
    sequence, symb_durs, durs_rate, pitch_coefs, = _0
    tts_model = self.tts_model
    _1 = torch.to(sequence, torch.device(device))
    _2 = torch.to(speaker_ids, torch.device(device))
    _3 = torch.to(durs_rate, torch.device(device))
    _4 = torch.to(pitch_coefs, torch.device(device))
    _5 = (tts_model).forward(_1, _2, sr, symb_durs, _3, _4, gt_durs, gt_pitch, device, )
    audio, audio_lengths, = _5
    return (audio, audio_lengths)
  def merge_batch_model(self: __torch__.silero_vocoder.jit_model.TTSSystem,
    texts: List[str],
    break_lens: List[Optional[int]],
    prosody_rates: List[float],
    prosody_pitches: List[float]) -> Tuple[Tensor, Dict[int, int], Tensor, Tensor]:
    symb_durs = annotate(Dict[int, int], {})
    final_rates = annotate(List[float], [])
    final_pitches = annotate(List[float], [])
    _6 = [9223372036854775807, torch.len(break_lens)]
    text_len = -1
    for i in range(ops.prim.min(_6)):
      break_len = break_lens[i]
      _7 = torch.sub(torch.len(break_lens), 1)
      if torch.lt(i, _7):
        cur_text_len0 = torch.add(torch.len(texts[i]), 1)
        cur_text_len = cur_text_len0
      else:
        cur_text_len1 = torch.add(torch.len(texts[i]), 2)
        cur_text_len = cur_text_len1
      text_len0 = torch.add(text_len, cur_text_len)
      if torch.__isnot__(break_len, None):
        break_len0 = unchecked_cast(int, break_len)
        _8 = torch.sub(torch.len(break_lens), 1)
        if torch.lt(i, _8):
          torch._set_item(symb_durs, text_len0, break_len0)
        else:
          torch._set_item(symb_durs, torch.sub(text_len0, 1), break_len0)
      else:
        pass
      rate = prosody_rates[i]
      torch.extend(final_rates, torch.mul([rate], cur_text_len))
      pitch = prosody_pitches[i]
      torch.extend(final_pitches, torch.mul([pitch], cur_text_len))
      text_len = text_len0
    full_text = torch.join(" ", texts)
    _9 = (self).preprocess_tacotron(full_text, )
    text_tensor = torch.unsqueeze(_9, 0)
    rate_tensor = torch.unsqueeze(torch.tensor(final_rates), 0)
    pitch_tensor = torch.unsqueeze(torch.tensor(final_pitches), 0)
    _10 = (text_tensor, symb_durs, rate_tensor, pitch_tensor)
    return _10
  def preprocess_tacotron(self: __torch__.silero_vocoder.jit_model.TTSSystem,
    text: str) -> Tensor:
    sos_token = self.sos_token
    _11 = torch.add(sos_token, text)
    eos_token = self.eos_token
    text0 = torch.add(_11, eos_token)
    text_ohe = annotate(List[int], [])
    for _12 in range(torch.len(text0)):
      s = text0[_12]
      symbol_to_id = self.symbol_to_id
      _13 = torch.append(text_ohe, symbol_to_id[s])
    return torch.to(torch.tensor(text_ohe), 4)
class MultiTTSModel(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  point_id : int
  comma_ids : List[int]
  mean_std_coef : List[float]
  sil_value : float
  tacotron : __torch__.jit_forward_model.JitMultiForward
  vocoder : __torch__.vocoder.hifigan.jit_vocoder.JitGenerator
  dur_predictor : __torch__.jit_forward_model.JitDurPredictor
  pitch_predictor : __torch__.jit_forward_model.JitPitchPredictor
  def forward(self: __torch__.silero_vocoder.jit_model.MultiTTSModel,
    sequence: Tensor,
    speaker_ids: Tensor,
    sr: int=48000,
    symb_durs: Optional[Dict[int, int]]=None,
    durs_rate: Optional[Tensor]=None,
    pitch_coefs: Optional[Tensor]=None,
    gt_durs: Optional[Tensor]=None,
    gt_pitch: Optional[Tensor]=None,
    device: str="cpu") -> Tuple[Tensor, Tensor]:
    _14 = __torch__.tacotron2.fastpitch_layers.make_token_len_mask
    _15 = uninitialized(Tensor)
    _16 = _14(torch.transpose(sequence, 0, 1), )
    orig_mask = torch.to(_16, torch.device(device))
    if torch.__isnot__(symb_durs, None):
      symb_durs1 = unchecked_cast(Dict[int, int], symb_durs)
      _18 = torch.gt(torch.len(symb_durs1), 0)
      _17, symb_durs0 = _18, symb_durs1
    else:
      _17, symb_durs0 = False, symb_durs
    if _17:
      symb_durs3 = unchecked_cast(Dict[int, int], symb_durs0)
      support_ids0 = (self).get_support_ids(sequence, symb_durs3, )
      support_ids, symb_durs2 = support_ids0, symb_durs3
    else:
      support_ids, symb_durs2 = None, symb_durs0
    if torch.__isnot__(support_ids, None):
      support_ids2 = unchecked_cast(List[int], support_ids)
      support_sequence0 = (self).replace_comma(sequence, support_ids2, )
      support_ids1, support_sequence = support_ids2, support_sequence0
    else:
      support_ids1, support_sequence = support_ids, sequence
    if torch.__is__(gt_durs, None):
      if torch.__isnot__(symb_durs2, None):
        symb_durs6 = unchecked_cast(Dict[int, int], symb_durs2)
        _20 = torch.gt(torch.len(symb_durs6), 0)
        _19, symb_durs5 = _20, symb_durs6
      else:
        _19, symb_durs5 = False, symb_durs2
      if _19:
        symb_durs8 = unchecked_cast(Dict[int, int], symb_durs5)
        _22 = torch.__isnot__(support_ids1, None)
        _21, symb_durs7 = _22, symb_durs8
      else:
        _21, symb_durs7 = False, symb_durs5
      if _21:
        symb_durs10 = unchecked_cast(Dict[int, int], symb_durs7)
        support_ids4 = unchecked_cast(List[int], support_ids1)
        _23 = torch.eq((torch.size(sequence))[0], 1)
        if _23:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        support_sequence1 = torch.to(support_sequence, torch.device(device))
        dur_predictor = self.dur_predictor
        _24 = torch.cat([sequence, support_sequence1])
        _25 = torch.cat([orig_mask, orig_mask])
        pred_log_dur0 = (dur_predictor).forward(_24, speaker_ids, _25, 1., )
        pred_log_dur, symb_durs9, support_ids3 = pred_log_dur0, symb_durs10, support_ids4
      else:
        dur_predictor0 = self.dur_predictor
        pred_log_dur1 = (dur_predictor0).forward(sequence, speaker_ids, orig_mask, 1., )
        pred_log_dur, symb_durs9, support_ids3 = pred_log_dur1, symb_durs7, support_ids1
      pred_log_dur2 = torch.sub(torch.exp(pred_log_dur), 1)
      _26 = torch.lt(pred_log_dur2, 0.)
      _27 = torch.tensor(0., dtype=ops.prim.dtype(pred_log_dur2), device=ops.prim.device(pred_log_dur2))
      _28 = annotate(List[Optional[Tensor]], [_26])
      _29 = torch.index_put_(pred_log_dur2, _28, _27)
      dur_hat0 = torch.round(pred_log_dur2)
      if torch.__isnot__(symb_durs9, None):
        symb_durs12 = unchecked_cast(Dict[int, int], symb_durs9)
        _31 = torch.gt(torch.len(symb_durs12), 0)
        _30, symb_durs11 = _31, symb_durs12
      else:
        _30, symb_durs11 = False, symb_durs9
      if _30:
        symb_durs14 = unchecked_cast(Dict[int, int], symb_durs11)
        _32 = torch.__isnot__(support_ids3, None)
        if _32:
          support_ids5 = unchecked_cast(List[int], support_ids3)
          sdurs = annotate(List[int], [])
          for _33 in range(torch.len(support_ids5)):
            sid = support_ids5[_33]
            _34 = torch.append(sdurs, symb_durs14[sid])
          pause_len = ops.prim.max(sdurs)
          dur_hat3 = (self).process_pauses(pred_log_dur2, support_ids5, pause_len, )
          dur_hat2 = dur_hat3
        else:
          dur_hat2 = dur_hat0
        dur_hat1, symb_durs13 = dur_hat2, symb_durs14
      else:
        dur_hat1, symb_durs13 = dur_hat0, symb_durs11
      if torch.__isnot__(durs_rate, None):
        durs_rate0 = unchecked_cast(Tensor, durs_rate)
        _35 = torch.eq(torch.size(durs_rate0), torch.size(dur_hat1))
        if _35:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        dur_hat4 = torch.div(dur_hat1, durs_rate0)
      else:
        dur_hat4 = dur_hat1
      _36 = torch.__isnot__(symb_durs13, None)
      if _36:
        symb_durs16 = unchecked_cast(Dict[int, int], symb_durs13)
        _38 = torch.gt(torch.len(symb_durs16), 0)
        _37, symb_durs15 = _38, symb_durs16
      else:
        _37, symb_durs15 = False, symb_durs13
      if _37:
        symb_durs18 = unchecked_cast(Dict[int, int], symb_durs15)
        _39 = torch.items(symb_durs18)
        for _40 in range(torch.len(_39)):
          sid0, sdur, = _39[_40]
          _41 = torch.select(torch.select(dur_hat4, 0, 0), 0, sid0)
          _42 = torch.tensor(sdur, dtype=ops.prim.dtype(_41), device=ops.prim.device(_41))
          _43 = torch.copy_(_41, _42)
        symb_durs17 : Optional[Dict[int, int]] = symb_durs18
      else:
        symb_durs17 = symb_durs15
      dur_hat, symb_durs4 = dur_hat4, symb_durs17
    else:
      dur_hat, symb_durs4 = unchecked_cast(Tensor, gt_durs), symb_durs2
    _44 = torch.mul(dur_hat, torch.bitwise_not(orig_mask))
    mel_lengths = torch.sum(_44, [1])
    if torch.__is__(gt_pitch, None):
      pitch_predictor = self.pitch_predictor
      pitch_hat0 = (pitch_predictor).forward(sequence, speaker_ids, orig_mask, )
      _45 = torch.__isnot__(pitch_coefs, None)
      if _45:
        pitch_coefs0 = unchecked_cast(Tensor, pitch_coefs)
        pitch_hat2 = (self).update_pitch_coef(pitch_hat0, pitch_coefs0, speaker_ids, )
        pitch_hat1 = pitch_hat2
      else:
        pitch_hat1 = pitch_hat0
      pitch_hat = pitch_hat1
    else:
      pitch_hat = unchecked_cast(Tensor, gt_pitch)
    tacotron = self.tacotron
    mel_outputs = (tacotron).forward(sequence, speaker_ids, orig_mask, dur_hat, pitch_hat, )
    if torch.__isnot__(symb_durs4, None):
      symb_durs20 = unchecked_cast(Dict[int, int], symb_durs4)
      _47 = torch.gt(torch.len(symb_durs20), 0)
      _46, symb_durs19 = _47, symb_durs20
    else:
      _46, symb_durs19 = False, symb_durs4
    if _46:
      symb_durs21 = unchecked_cast(Dict[int, int], symb_durs19)
      mel_outputs1 = (self).fx_pauses(mel_outputs, dur_hat, symb_durs21, )
      mel_outputs0 = mel_outputs1
    else:
      mel_outputs0 = mel_outputs
    vocoder = self.vocoder
    audio = (vocoder).forward(mel_outputs0, sr, )
    if torch.__isnot__(audio, None):
      audio0 = unchecked_cast(Tensor, audio)
    else:
      ops.prim.RaiseException("AssertionError: ")
      audio0 = _15
    audio1 = torch.detach(audio0)
    audio2 = torch.squeeze(audio1, 1)
    _48 = torch.mul(torch.detach(mel_lengths), sr)
    audio_lengths = torch.div(_48, 80)
    return (audio2, audio_lengths)
  def get_support_ids(self: __torch__.silero_vocoder.jit_model.MultiTTSModel,
    sequence: Tensor,
    symb_durs: Dict[int, int]) -> Optional[List[int]]:
    temp_ids = annotate(List[int], [])
    _49 = torch.keys(symb_durs)
    for _50 in range(torch.len(_49)):
      sid = _49[_50]
      _51 = torch.select(torch.select(sequence, 0, 0), 0, sid)
      comma_ids = self.comma_ids
      _52 = torch.__contains__(comma_ids, annotate(int, _51))
      if _52:
        _53 = torch.append(temp_ids, sid)
      else:
        pass
    if torch.gt(torch.len(temp_ids), 0):
      support_ids : Optional[List[int]] = temp_ids
    else:
      support_ids = None
    return support_ids
  def replace_comma(self: __torch__.silero_vocoder.jit_model.MultiTTSModel,
    sequence: Tensor,
    support_ids: List[int]) -> Tensor:
    support_sequence = torch.clone(sequence)
    point_id = self.point_id
    _54 = torch.tensor(support_ids, dtype=4)
    _55 = torch.slice(support_sequence)
    _56 = torch.tensor(point_id, dtype=ops.prim.dtype(_55), device=ops.prim.device(_55))
    _57 = annotate(List[Optional[Tensor]], [None, _54])
    _58 = torch.index_put_(_55, _57, _56)
    return support_sequence
  def process_pauses(self: __torch__.silero_vocoder.jit_model.MultiTTSModel,
    comma_point_durs: Tensor,
    comma_ids: List[int],
    pause_len: int) -> Tensor:
    _59 = torch.tensor(comma_ids, dtype=4)
    _60 = torch.slice(comma_point_durs)
    _61 = annotate(List[Optional[Tensor]], [None, _59])
    _62, _63 = torch.min(torch.index(_60, _61), 1)
    comma_len = torch.item(torch.select(_62, 0, 0))
    point_len = torch.item(torch.select(_62, 0, 1))
    if torch.gt(comma_len, point_len):
      _64 = True
    else:
      _64 = torch.le(pause_len, comma_len)
    if _64:
      final_dur0 = torch.select(comma_point_durs, 0, 0)
      final_dur = final_dur0
    else:
      if torch.ge(pause_len, point_len):
        final_dur2 = torch.select(comma_point_durs, 0, 1)
        final_dur1 = final_dur2
      else:
        point_cf = torch.div(torch.sub(pause_len, comma_len), torch.sub(point_len, comma_len))
        comma_cf = torch.div(torch.sub(point_len, pause_len), torch.sub(point_len, comma_len))
        _65 = torch.select(comma_point_durs, 0, 0)
        _66 = torch.mul(_65, comma_cf)
        _67 = torch.select(comma_point_durs, 0, 1)
        final_dur3 = torch.add(_66, torch.mul(_67, point_cf))
        final_dur1 = final_dur3
      final_dur = final_dur1
    final_dur4 = torch.unsqueeze(final_dur, 0)
    return torch.round(final_dur4)
  def update_pitch_coef(self: __torch__.silero_vocoder.jit_model.MultiTTSModel,
    norm_pitch: Tensor,
    pitch_coef: Tensor,
    speaker_ids: Tensor) -> Tensor:
    norm_pitch_coefd = torch.mul(norm_pitch, pitch_coef)
    _68 = torch.eq(torch.select(pitch_coef, 0, 0), 0)
    _69 = (torch.where(_68))[0]
    _70 = torch.slice(pitch_coef)
    _71 = torch.tensor(1., dtype=ops.prim.dtype(_70), device=ops.prim.device(_70))
    _72 = annotate(List[Optional[Tensor]], [None, _69])
    _73 = torch.index_put_(_70, _72, _71)
    mean_std_coef = self.mean_std_coef
    _74 = mean_std_coef[int(torch.item(speaker_ids))]
    mean_std_shift = torch.mul(torch.sub(pitch_coef, 1.), _74)
    norm_pitch_shift = torch.add(norm_pitch_coefd, mean_std_shift)
    return norm_pitch_shift
  def fx_pauses(self: __torch__.silero_vocoder.jit_model.MultiTTSModel,
    mel_outputs: Tensor,
    dur_hat: Tensor,
    symb_durs: Dict[int, int]) -> Tensor:
    _75 = torch.keys(symb_durs)
    for _76 in range(torch.len(_75)):
      sid = _75[_76]
      _77 = torch.slice(torch.select(dur_hat, 0, 0), 0, None, sid)
      dur_sum = int(torch.item(torch.sum(_77)))
      _78 = torch.select(torch.select(dur_hat, 0, 0), 0, sid)
      sdur = int(torch.item(_78))
      if torch.gt(sdur, 10):
        sil_value = self.sil_value
        _79 = torch.slice(torch.slice(mel_outputs), 1)
        _80 = torch.slice(_79, 2, torch.add(dur_sum, 10), torch.add(dur_sum, sdur))
        _81 = torch.tensor(sil_value, dtype=ops.prim.dtype(_80), device=ops.prim.device(_80))
        _82 = torch.copy_(_80, _81)
      else:
        sil_value0 = self.sil_value
        _83 = torch.slice(torch.slice(mel_outputs), 1)
        _84 = torch.slice(_83, 2, dur_sum, torch.add(dur_sum, sdur))
        _85 = torch.tensor(sil_value0, dtype=ops.prim.dtype(_84), device=ops.prim.device(_84))
        _86 = torch.copy_(_84, _85)
    return mel_outputs
